version: '3'
services:
  ionic:
    build:
      context: ./Ionic
    image: registry.gitlab.com/m.pelucchi/assigment1/ionic-app
    volumes:
      - ./Ionic/src/:/usr/share/nginx/html
    ports:
      - "8100:80"
  php:
    build:
      context: ./PHP
    image: registry.gitlab.com/m.pelucchi/assigment1/php-app
    volumes:
      - ./PHP/src/:/var/www/html/
    ports:
      - "80:80"
    links:
      - mysql
  mysql:
    build:
      context: ./MyDB
    image: registry.gitlab.com/m.pelucchi/assigment1/mysql-app
    volumes:
      - mysqldata:/var/lib/mysql
    ports:
      - "3306:3306"
  prometheus:
    image: prom/prometheus:latest
    volumes:
      - ./prometheus/prometheus.yml:/etc/prometheus/prometheus.yml
      - prometheusdata:/etc/prometheus
    command:
        - '--config.file=/etc/prometheus/prometheus.yml'
    ports:
      - "9090:9090"
    links:
      - exporter
  exporter:
    image: prom/mysqld-exporter
    restart: always
    ports: 
      - "9104:9104"
    links:
      - mysql
    environment:
       DATA_SOURCE_NAME: "root:Salinello1@(mysql:3306)/mydb"
    command: '--collect.global_variables --collect.slave_status --collect.binlog_size --collect.info_schema.innodb_metrics --collect.auto_increment.columns --collect.engine_tokudb_status --collect.info_schema.userstats --collect.info_schema.innodb_tablespaces --collect.info_schema.tablestats --collect.info_schema.tables --collect.info_schema.query_response_time --collect.info_schema.processlist --collect.perf_schema.eventsstatements --collect.perf_schema.indexiowaits --collect.perf_schema.tableiowaits --collect.perf_schema.tablelocks --collect.perf_schema.file_events --collect.perf_schema.eventswaits'  
  grafana:
    image: grafana/grafana
    ports:
      - '3000:3000'
    volumes:
      - grafanadata:/var/lib/grafana
      - ./grafana/provisioning/:/etc/grafana/provisioning/
    env_file:
      - ./grafana/config.monitoring
    restart: always

volumes:
  mysqldata:
  grafanadata:
  prometheusdata: